function [X_RL,Y_RL,Z_RL,Xlocal_RL,Ylocal_RL,Zlocal_RL,TempDef_RL,ARRAYdate_RL,...
    ErrRadialLink] = elab2D_RL(rRL,accRL,ACCdefRis_RL,SpeRL,IDcentralina,DTcatena,...
    DatiElabRadialLink,NuovoZeroRL,tolleranzaAcc,TempDef_RL,Ndevst,Wdevst,ARRAYdate_RL,...
    elab_option,NdatiMedia,Ndatidespike,margine,ErrRadialLink,Tmax,Tmin,datainiRL,FileName)

 %% Inizializzazione
fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'elab2D_RL function started';
fprintf(fileID,fmt,text);

if NuovoZeroRL == 1
    if NdatiMedia > Ndatidespike
        Ndati = NdatiMedia;
    else
        Ndati = Ndatidespike;
    end
    ini = round(Ndati/2)+1;
    if rem(Ndati,2) == 0
        ini = ini+1;
    end
    clear NDati
    ini = ini + margine;
    if ini < 6
        ini = 6;
    end
    if Ndevst ~= 0 % Allora prendo tutti i dati e solo in seguito considero i nuovi, a valle della funzione filtro
        ini = 1;
    end
    DatiElabRadialLink = DatiElabRadialLink(ini:end,:);
    ACCdefRis_RL = ACCdefRis_RL(ini:end,:);
    ARRAYdate_RL = ARRAYdate_RL(ini:end,1);
    TempDef_RL = TempDef_RL(ini:end,:);
    accRL = accRL(ini:end,:);
    ErrRadialLink = ErrRadialLink(ini:end,:);
end

%% Definizione dei dati
Nnodi = rRL;
[r,~] = size(accRL);
[Ndati,~] = size(ARRAYdate_RL);
ax = zeros(r,Nnodi);
ay = zeros(r,Nnodi);
az = zeros(r,Nnodi);
for i=1:Nnodi
    ax(:,i) = accRL(:,(i-1)*3+1); % ax
    ay(:,i) = accRL(:,(i-1)*3+2:(i-1)*3+2); % ay
    az(:,i) = accRL(:,(i-1)*3+3:(i-1)*3+3); % az
end

ax = ax'; % riga nodi, colonna date
ay = ay'; % riga nodi, colonna date
az = az'; % riga nodi, colonna date
% Dati locali
asseX_RL = zeros(Nnodi,Ndati); % Raccoglie i dati locali nella sezione della galleria, in direzione orizzontale
asseY_RL = zeros(Nnodi,Ndati); % Raccoglie i dati locali nella direzione trasversale rispetto alla sezione della galleria
asseZ_RL = zeros(Nnodi,Ndati); % Raccoglie i dati locali nella sezione della galleria, in altezza
% Dati cumulati
X_RL = zeros(Nnodi,Ndati); % Raccoglie i dati cumulati nella sezione della galleria, in direzione orizzontale
Y_RL = zeros(Nnodi,Ndati); % Raccoglie i dati cumulati nella direzione trasversale rispetto alla sezione della galleria
Z_RL = zeros(Nnodi,Ndati); % Raccoglie i dati cumulati nella sezione della galleria, in altezza
% parametri per il calcolo
SpeRL = SpeRL(2:end,1); % valori di primo tentativo segmenti di pertinenza

%% Applico le correzioni post installazione
if NuovoZeroRL == 0
    [ax,ay,az] = check_RL(ax,ay,az,rRL,IDcentralina,DTcatena,FileName);
else
    incliX = ax;
    incliY = ay;
    incliZ = az;
    nameXY = strcat([IDcentralina,'-',DTcatena,'-','switchXY']);
    name_switchXY = strcat([IDcentralina,'-',DTcatena,'-','switch_signXY']);
    nameYZ = strcat([IDcentralina,'-',DTcatena,'-','switchYZ']);
    switchXY = load(nameXY);
    switchYZ = load(nameYZ);
    switch_signXY = load(name_switchXY);
    switchXY = switchXY.switchXY;
    switch_signXY = switch_signXY.switch_signXY;
    switchYZ = switchYZ.switchYZ;
    for i = 1:rRL
        if switch_signXY(i,1) == 1
            ax(i,:) = -incliX(i,:);
            ay(i,:) = -incliY(i,:);
        end
        if switchXY(i,1) == 1
            ax(i,:) = incliY(i,:);
            ay(i,:) = incliX(i,:);
        elseif switchXY(i,1) == -1
            ax(i,:) = -incliY(i,:);
            ay(i,:) = -incliX(i,:);
        end
        if switchYZ(i,1) == 1
            az(i,:) = -incliY(i,:);
            ay(i,:) = -incliZ(i,:);
        end
    end
end

%% Calcolo
for jj = 1:Ndati
    if jj == 1 % al primo dato raccolto riporto i punti di calcolo sui punti noti
       if NuovoZeroRL == 0
          [cXo,cYo,cZo,asseX_RL,asseY_RL,asseZ_RL] = punti_noti_RL(IDcentralina,...
              DTcatena,asseX_RL,asseY_RL,asseZ_RL,FileName);
       elseif NuovoZeroRL == 1 % calcolo a partire da dati già elaborati a cui mi riferisco
              [cXo,cYo,cZo,asseX_RL,asseY_RL,asseZ_RL] = punti_noti_exe_RL...
                  (asseX_RL,asseY_RL,asseZ_RL,DatiElabRadialLink,FileName);
       end
       for ii = 1:Nnodi
           [X_RL,Y_RL,Z_RL,asseX_RL,asseY_RL,asseZ_RL] = CalcoloBiax_RL(SpeRL,...
                ii,jj,ax,ay,asseX_RL,asseY_RL,asseZ_RL,X_RL,Y_RL,Z_RL,elab_option);
       end
       [shiftX_RL,shiftY_RL,shiftZ_RL] = pos_ini_RL(cXo,cYo,cZo,X_RL,Y_RL,Z_RL);      
    else
        for ii = 1:Nnodi
           [X_RL,Y_RL,Z_RL,asseX_RL,asseY_RL,asseZ_RL] = CalcoloBiax_RL(SpeRL,...
                ii,jj,ax,ay,asseX_RL,asseY_RL,asseZ_RL,X_RL,Y_RL,Z_RL,elab_option);
        end
    end
    % riporto X, Y e Z sui punti noti
    X_RL(:,jj) = X_RL(:,jj) - shiftX_RL(:,1);
    Y_RL(:,jj) = Y_RL(:,jj) - shiftY_RL(:,1);
    Z_RL(:,jj) = Z_RL(:,jj) - shiftZ_RL(:,1);
end

Xrif = X_RL; % mi serve dopo
Yrif = Y_RL; % mi serve dopo
Zrif = Z_RL; % mi serve dopo
dX_RL = diff(asseX_RL,1,2);
dY_RL = diff(asseY_RL,1,2);
dZ_RL = diff(asseZ_RL,1,2);

%% Controllo della risultante delle accelerazioni
clear r
clear rr
clear c
clear cc
ACCdefRis_RL = ACCdefRis_RL';  % Nodi in riga, date in colonna
[r,c] = size(ACCdefRis_RL);
[rr,cc] = size(X_RL);

% controllo che le matrici con le risultanti delle accelerazioni e 
% le matrici con i dati di spostamento abbiano le stesse dimensioni
if r~=rr
    text = '---Warning! Number of row of displacement data do not correspond to the number of acceleration cosine vector!---';
    fprintf(fileID,fmt,text);
end
if c~=cc
    text = '---Warning! Number of column of displacement data do not correspond to the number of acceleration cosine vector!---';
    fprintf(fileID,fmt,text);
end
fileID = fopen(FileName,'a');
fmt = '%s \r';
fprintf(fileID,fmt,text);
clear i
clear j
cont = 1; % contatore
cont2 = 1; % contatore
cont3 = 1; % contatore
TempDef_RL = TempDef_RL';
text1 = 'There are not correction of Radial Link based on acceleration vector filter';
text2 = 'There are not correction of Radial Link based on uncalibrated Acceleration vector';
text3 = 'There are not correction of Radial Link based on temperature filter';
for j = 2:c % data
    for i = 1:r % nodo
        % se il valore assoluto della differenza è maggiore della
        % tolleranza, pongo gli spostamenti giornalieri pari a 0
        if abs(ACCdefRis_RL(i,j)-ACCdefRis_RL(i,j-1)) > tolleranzaAcc 
            dX_RL(i,j-1) = 0;
            dY_RL(i,j-1) = 0;
            dZ_RL(i,j-1) = 0;
            text1 = ['' num2str(cont) ' correction executed for Radial Link - Acceleration vector filter!'];
            cont = cont+1;
        end
        if ACCdefRis_RL(i,j) < 0.9 || ACCdefRis_RL(i,j) > 1.1 % Il nodo è fuori taratura! 
            dX_RL(i,j-1) = 0;
            dY_RL(i,j-1) = 0;
            dZ_RL(i,j-1) = 0;
            TempDef_RL(i,j) = TempDef_RL(i,j-1);
            text2 = ['' num2str(cont3) ' correction executed for Tilt Link V - uncalibrated Acceleration vector!'];
            cont3 = cont3+1;
        end
    end
end

FileTemperature = ['' IDcentralina '-' DTcatena '-RL-Therm.csv'];
if isfile(FileTemperature) == 1
    DatiRaw = csvread(FileTemperature);
    [rDR,cDR] = size(DatiRaw);
    DatiRaw(:,1) = DatiRaw(:,1) + 730000;
else
    rDR = 1;
    cDR = 1;
end
for b = 1:c % Data
    for a = 1:r % Nodo
        % NON considero i dati al di sopra dei 80 °C o al di sotto dei -30 °C! 
        if TempDef_RL(a,b) > Tmax || TempDef_RL(a,b) < Tmin
            cont2 = cont2+1;
            if b == 1
                if isfile(FileTemperature) == 1
                    RawDate = find(DatiRaw(:,1)<=datenum(datainiRL));
                    if isempty(RawDate) == 1
                        cc = 2;
                        while cc <= c
                            if TempDef_RL(a,cc) > Tmax || TempDef_RL(a,cc) < Tmin
                                cc = cc+1;
                            else
                                break
                            end
                        end
                        TempDef_RL(a,b) = TempDef_RL(a,cc);
                    else
                        if isnan(DatiRaw(RawDate(end),a+1)) == 0
                            TempDef_RL(a,b) = DatiRaw(RawDate(end),a+1);
                            ErrRadialLink(b,a) = 0.5;
                            wardat = 'Temperature data of Radial Link nodes corrected using Raw Data of reference Csv file.';
                            fprintf(fileID,fmt,wardat);
                        else
                            cc = 2;
                            while cc <= c
                                if TempDef_RL(a,cc) > Tmax || TempDef_RL(a,cc) < Tmin
                                    cc = cc+1;
                                else
                                    break
                                end
                            end
                            TempDef_RL(a,b) = TempDef_RL(a,cc);
                        end
                    end
                else
                    cc = 2;
                    while cc <= c
                        if TempDef_RL(a,cc) > Tmax || TempDef_RL(a,cc) < Tmin
                            cc = cc+1;
                        else
                            break
                        end
                    end
                    TempDef_RL(a,b) = TempDef_RL(a,cc);
                end
            else
                TempDef_RL(a,b) = TempDef_RL(a,b-1);
                dX_RL(a,b-1) = 0;
                dY_RL(a,b-1) = 0;
                dZ_RL(a,b-1) = 0;
                ErrRadialLink(b,a) = 0.5;
            end
            text3 = ['' num2str(cont2) ' correction executed for Radial Link - Temperature filter!'];
        end
    end
end

if  rDR~=1 && cDR~=1 && isempty(DatiRaw) == 0
    RawDate1 = find(DatiRaw(:,1)<=ARRAYdate_RL(1));
    if isempty(RawDate1) == 1
        RawDate2 = 1;
    elseif RawDate1(end) == rDR
        RawDate2 = find(ARRAYdate_RL(:,1)>DatiRaw(end,1));
    else
        RawDate2 = find(ARRAYdate_RL(:,1)>DatiRaw(RawDate1(end)+1,1));
    end
else
    RawDate1 = [];
    RawDate2 = 1;
end
if isempty(RawDate1) == 0 && isempty(RawDate2) == 0
    Dati = [DatiRaw(1:RawDate1(end),:); ARRAYdate_RL(RawDate2(1):end) TempDef_RL(:,RawDate2(1):end)'];
elseif isempty(RawDate1) == 1 && isempty(RawDate2) == 0
    Dati = [ARRAYdate_RL TempDef_RL'];
else
    Dati = DatiRaw;
end
% Elimino appoggio più vecchio di un mese
RawDate3 = find(Dati(:,1)<now-30);
if isempty(RawDate3) == 0
    [rDati,~] = size(Dati);
    if RawDate3(end) == rDati
    else
        Dati = Dati(RawDate3(end)+1:end,:);
    end
end
if isfile(FileTemperature) == 1
    delete(FileTemperature);
end
Dati(:,1) = Dati(:,1) - 730000;
csvwrite(FileTemperature,Dati);

TempDef_RL = TempDef_RL';
fprintf(fileID,fmt,text1);
fprintf(fileID,fmt,text2);
fprintf(fileID,fmt,text3);

fprintf(fileID,fmt,'filtro_RL function started');
%% Filtro
[dX_RL,dY_RL,dZ_RL,text4] = filtro_RL(dX_RL,dY_RL,dZ_RL,Ndevst,Wdevst);
fprintf(fileID,fmt,'filtro_RL function closed');
fprintf(fileID,fmt,text4);
if NuovoZeroRL == 1 && Ndevst ~= 0
    if NdatiMedia > Ndatidespike
        NdatiF = NdatiMedia;
    else
        NdatiF = Ndatidespike;
    end
    ini = round(NdatiF/2)+1;
    if rem(NdatiF,2) == 0
        ini = ini+1;
    end
    clear NDatiF
    iniST = round(Wdevst/2);
    if rem(Wdevst,2) == 0
        iniST = iniST+1;
    end
    iniST = iniST + margine;
    if iniST > ini
        ini = iniST;
    end
    if ini < 6
        ini = 6;
    end
    dX_RL = dX_RL(:,ini:end);
    dY_RL = dY_RL(:,ini:end);
    dZ_RL = dZ_RL(:,ini:end);
    TempDef_RL = TempDef_RL(ini:end,:);
    DatiElabRadialLink = DatiElabRadialLink(ini:end,:);
    ARRAYdate_RL = ARRAYdate_RL(ini:end,1); 
    ErrRadialLink = ErrRadialLink(ini:end,:);
end

%% Finalizzo i calcoli
[rx,cx] = size(dX_RL);

% totale del singolo nodo data per data
sommaX_RL = zeros(rx,cx+1);
sommaY_RL = zeros(rx,cx+1);
sommaZ_RL = zeros(rx,cx+1);

% cumulata del singolo nodo data per data in posizione assoluta
% il primo valore è quello di posizione assoluta iniziale
X_RL = zeros(rx,cx+1);
Y_RL = zeros(rx,cx+1);
Z_RL = zeros(rx,cx+1);

% cumulata del singolo nodo data per data in posizione relativa
% il primo valore è quello di 0
Xlocal_RL = zeros(Nnodi,Ndati);
Ylocal_RL = zeros(Nnodi,Ndati);
Zlocal_RL = zeros(Nnodi,Ndati);

% Primo dato
X_RL(:,1) = Xrif(:,1);
Y_RL(:,1) = Yrif(:,1);
Z_RL(:,1) = Zrif(:,1);

if NuovoZeroRL == 1
    [~,cE] = size(DatiElabRadialLink);
    cont = 3;
    n = 1;
    while cont<=cE
        sommaX_RL(n,1) = cell2mat(DatiElabRadialLink(1,cont))';
        Xlocal_RL(n,1) = sommaX_RL(n,1);
        sommaY_RL(n,1) = cell2mat(DatiElabRadialLink(1,cont+1))';
        Ylocal_RL(n,1) = sommaY_RL(n,1);
        sommaZ_RL(n,1) = cell2mat(DatiElabRadialLink(1,cont+2))';
        Zlocal_RL(n,1) = sommaZ_RL(n,1);
        cont=cont+9;
        n = n+1;
    end
end
    
for iii = 1:cx % date
    % somma singoli spostamenti del singolo nodo
    sommaX_RL(:,iii+1) = sum(dX_RL(:,1:iii),2) + sommaX_RL(:,1);
    sommaY_RL(:,iii+1) = sum(dY_RL(:,1:iii),2) + sommaY_RL(:,1);
    sommaZ_RL(:,iii+1) = sum(dZ_RL(:,1:iii),2) + sommaZ_RL(:,1);
    % spostamenti locali riferiti allo 0
    Xlocal_RL(:,iii+1) = sommaX_RL(:,iii+1);
    Ylocal_RL(:,iii+1) = sommaY_RL(:,iii+1);
    Zlocal_RL(:,iii+1) = sommaZ_RL(:,iii+1);
    % cumulata spostamenti
    X_RL(:,iii+1) = Xrif(:,1) + cumsum(sommaX_RL(:,iii+1)) - cumsum(sommaX_RL(:,1));
    Y_RL(:,iii+1) = Yrif(:,1) + cumsum(sommaY_RL(:,iii+1)) - cumsum(sommaY_RL(:,1));
    Z_RL(:,iii+1) = Zrif(:,1) + cumsum(sommaZ_RL(:,iii+1)) - cumsum(sommaZ_RL(:,1));
end

%% Approssimazioni
[X_RL,Y_RL,Z_RL,Xlocal_RL,Ylocal_RL,Zlocal_RL,TempDef_RL] = ...
    approx_RL(X_RL,Y_RL,Z_RL,Xlocal_RL,Ylocal_RL,Zlocal_RL,TempDef_RL,FileName);

fileID = fopen(FileName,'a');
fmt = '%s \r';

[r,~] = size(ErrRadialLink);
Matrice_err = zeros(r,rRL);
for i = 1:r % date
    d = 1;
    for n = 1:rRL % nodi
        j = 1;
        err = ErrRadialLink(i,d:d+3);
        while j <= 4
            if err(1,j) == 1
                Matrice_err(i,n) = 1;
            end
            j = j+1;
        end
        d = d+4;
    end
end
ErrRadialLink = Matrice_err';
    
text4 = 'Radial Link calculation executed correctly. elab2D_RL function closed';
fprintf(fileID,fmt,text4);
fclose(fileID);

end
    